<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Asset_Pooling_Rule_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing request references for the asset pooling rules operation
 * @subpackage Structs
 */
class Asset_Pooling_Rule_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Asset_Pooling_Rule_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing asset pooling rule to which the asset pooling rule data applies
     * - maxOccurs: unbounded
     * @var \StructType\Asset_Pooling_RuleObjectType[]
     */
    public $Asset_Pooling_Rule_Reference;
    /**
     * Constructor method for Asset_Pooling_Rule_Request_ReferencesType
     * @uses Asset_Pooling_Rule_Request_ReferencesType::setAsset_Pooling_Rule_Reference()
     * @param \StructType\Asset_Pooling_RuleObjectType[] $asset_Pooling_Rule_Reference
     */
    public function __construct(array $asset_Pooling_Rule_Reference = array())
    {
        $this
            ->setAsset_Pooling_Rule_Reference($asset_Pooling_Rule_Reference);
    }
    /**
     * Get Asset_Pooling_Rule_Reference value
     * @return \StructType\Asset_Pooling_RuleObjectType[]|null
     */
    public function getAsset_Pooling_Rule_Reference()
    {
        return $this->Asset_Pooling_Rule_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setAsset_Pooling_Rule_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAsset_Pooling_Rule_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAsset_Pooling_Rule_ReferenceForArrayConstraintsFromSetAsset_Pooling_Rule_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $asset_Pooling_Rule_Request_ReferencesTypeAsset_Pooling_Rule_ReferenceItem) {
            // validation for constraint: itemType
            if (!$asset_Pooling_Rule_Request_ReferencesTypeAsset_Pooling_Rule_ReferenceItem instanceof \StructType\Asset_Pooling_RuleObjectType) {
                $invalidValues[] = is_object($asset_Pooling_Rule_Request_ReferencesTypeAsset_Pooling_Rule_ReferenceItem) ? get_class($asset_Pooling_Rule_Request_ReferencesTypeAsset_Pooling_Rule_ReferenceItem) : sprintf('%s(%s)', gettype($asset_Pooling_Rule_Request_ReferencesTypeAsset_Pooling_Rule_ReferenceItem), var_export($asset_Pooling_Rule_Request_ReferencesTypeAsset_Pooling_Rule_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Asset_Pooling_Rule_Reference property can only contain items of type \StructType\Asset_Pooling_RuleObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Asset_Pooling_Rule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Asset_Pooling_RuleObjectType[] $asset_Pooling_Rule_Reference
     * @return \StructType\Asset_Pooling_Rule_Request_ReferencesType
     */
    public function setAsset_Pooling_Rule_Reference(array $asset_Pooling_Rule_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($asset_Pooling_Rule_ReferenceArrayErrorMessage = self::validateAsset_Pooling_Rule_ReferenceForArrayConstraintsFromSetAsset_Pooling_Rule_Reference($asset_Pooling_Rule_Reference))) {
            throw new \InvalidArgumentException($asset_Pooling_Rule_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Asset_Pooling_Rule_Reference = $asset_Pooling_Rule_Reference;
        return $this;
    }
    /**
     * Add item to Asset_Pooling_Rule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Asset_Pooling_RuleObjectType $item
     * @return \StructType\Asset_Pooling_Rule_Request_ReferencesType
     */
    public function addToAsset_Pooling_Rule_Reference(\StructType\Asset_Pooling_RuleObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Asset_Pooling_RuleObjectType) {
            throw new \InvalidArgumentException(sprintf('The Asset_Pooling_Rule_Reference property can only contain items of type \StructType\Asset_Pooling_RuleObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Asset_Pooling_Rule_Reference[] = $item;
        return $this;
    }
}
