<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Expense_Rate_Table_Rule_Response_GroupType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Expense Rate Table Rule response grouping options
 * @subpackage Structs
 */
class Expense_Rate_Table_Rule_Response_GroupType extends AbstractStructBase
{
    /**
     * The Include_Reference
     * Meta information extracted from the WSDL
     * - documentation: Include Reference
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Include_Reference;
    /**
     * The Exclude_Condition_Rule_Dependencies
     * Meta information extracted from the WSDL
     * - documentation: Exclude Condition Rule Dependencies
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Exclude_Condition_Rule_Dependencies;
    /**
     * Constructor method for Expense_Rate_Table_Rule_Response_GroupType
     * @uses Expense_Rate_Table_Rule_Response_GroupType::setInclude_Reference()
     * @uses Expense_Rate_Table_Rule_Response_GroupType::setExclude_Condition_Rule_Dependencies()
     * @param bool $include_Reference
     * @param bool $exclude_Condition_Rule_Dependencies
     */
    public function __construct($include_Reference = null, $exclude_Condition_Rule_Dependencies = null)
    {
        $this
            ->setInclude_Reference($include_Reference)
            ->setExclude_Condition_Rule_Dependencies($exclude_Condition_Rule_Dependencies);
    }
    /**
     * Get Include_Reference value
     * @return bool|null
     */
    public function getInclude_Reference()
    {
        return $this->Include_Reference;
    }
    /**
     * Set Include_Reference value
     * @param bool $include_Reference
     * @return \StructType\Expense_Rate_Table_Rule_Response_GroupType
     */
    public function setInclude_Reference($include_Reference = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_Reference) && !is_bool($include_Reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($include_Reference, true), gettype($include_Reference)), __LINE__);
        }
        $this->Include_Reference = $include_Reference;
        return $this;
    }
    /**
     * Get Exclude_Condition_Rule_Dependencies value
     * @return bool|null
     */
    public function getExclude_Condition_Rule_Dependencies()
    {
        return $this->Exclude_Condition_Rule_Dependencies;
    }
    /**
     * Set Exclude_Condition_Rule_Dependencies value
     * @param bool $exclude_Condition_Rule_Dependencies
     * @return \StructType\Expense_Rate_Table_Rule_Response_GroupType
     */
    public function setExclude_Condition_Rule_Dependencies($exclude_Condition_Rule_Dependencies = null)
    {
        // validation for constraint: boolean
        if (!is_null($exclude_Condition_Rule_Dependencies) && !is_bool($exclude_Condition_Rule_Dependencies)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($exclude_Condition_Rule_Dependencies, true), gettype($exclude_Condition_Rule_Dependencies)), __LINE__);
        }
        $this->Exclude_Condition_Rule_Dependencies = $exclude_Condition_Rule_Dependencies;
        return $this;
    }
}
