<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for External_Transaction_Source_Request_ReferencesType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing reference instances for External Transaction Sources
 * @subpackage Structs
 */
class External_Transaction_Source_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The External_Transaction_Source_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing External Transaction Source
     * - maxOccurs: unbounded
     * @var \StructType\External_Transaction_Source__All_ObjectType[]
     */
    public $External_Transaction_Source_Reference;
    /**
     * Constructor method for External_Transaction_Source_Request_ReferencesType
     * @uses External_Transaction_Source_Request_ReferencesType::setExternal_Transaction_Source_Reference()
     * @param \StructType\External_Transaction_Source__All_ObjectType[] $external_Transaction_Source_Reference
     */
    public function __construct(array $external_Transaction_Source_Reference = array())
    {
        $this
            ->setExternal_Transaction_Source_Reference($external_Transaction_Source_Reference);
    }
    /**
     * Get External_Transaction_Source_Reference value
     * @return \StructType\External_Transaction_Source__All_ObjectType[]|null
     */
    public function getExternal_Transaction_Source_Reference()
    {
        return $this->External_Transaction_Source_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setExternal_Transaction_Source_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExternal_Transaction_Source_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExternal_Transaction_Source_ReferenceForArrayConstraintsFromSetExternal_Transaction_Source_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $external_Transaction_Source_Request_ReferencesTypeExternal_Transaction_Source_ReferenceItem) {
            // validation for constraint: itemType
            if (!$external_Transaction_Source_Request_ReferencesTypeExternal_Transaction_Source_ReferenceItem instanceof \StructType\External_Transaction_Source__All_ObjectType) {
                $invalidValues[] = is_object($external_Transaction_Source_Request_ReferencesTypeExternal_Transaction_Source_ReferenceItem) ? get_class($external_Transaction_Source_Request_ReferencesTypeExternal_Transaction_Source_ReferenceItem) : sprintf('%s(%s)', gettype($external_Transaction_Source_Request_ReferencesTypeExternal_Transaction_Source_ReferenceItem), var_export($external_Transaction_Source_Request_ReferencesTypeExternal_Transaction_Source_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The External_Transaction_Source_Reference property can only contain items of type \StructType\External_Transaction_Source__All_ObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set External_Transaction_Source_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\External_Transaction_Source__All_ObjectType[] $external_Transaction_Source_Reference
     * @return \StructType\External_Transaction_Source_Request_ReferencesType
     */
    public function setExternal_Transaction_Source_Reference(array $external_Transaction_Source_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($external_Transaction_Source_ReferenceArrayErrorMessage = self::validateExternal_Transaction_Source_ReferenceForArrayConstraintsFromSetExternal_Transaction_Source_Reference($external_Transaction_Source_Reference))) {
            throw new \InvalidArgumentException($external_Transaction_Source_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->External_Transaction_Source_Reference = $external_Transaction_Source_Reference;
        return $this;
    }
    /**
     * Add item to External_Transaction_Source_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\External_Transaction_Source__All_ObjectType $item
     * @return \StructType\External_Transaction_Source_Request_ReferencesType
     */
    public function addToExternal_Transaction_Source_Reference(\StructType\External_Transaction_Source__All_ObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\External_Transaction_Source__All_ObjectType) {
            throw new \InvalidArgumentException(sprintf('The External_Transaction_Source_Reference property can only contain items of type \StructType\External_Transaction_Source__All_ObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->External_Transaction_Source_Reference[] = $item;
        return $this;
    }
}
