<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Issue_Asset_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Put operation.
 * @subpackage Structs
 */
class Issue_Asset_ResponseType extends AbstractStructBase
{
    /**
     * The Business_Asset_Issue_Reference
     * Meta information extracted from the WSDL
     * - documentation: Business Asset specified for Issue.
     * - minOccurs: 0
     * @var \StructType\Business_AssetObjectType
     */
    public $Business_Asset_Issue_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Issue_Asset_ResponseType
     * @uses Issue_Asset_ResponseType::setBusiness_Asset_Issue_Reference()
     * @uses Issue_Asset_ResponseType::setVersion()
     * @param \StructType\Business_AssetObjectType $business_Asset_Issue_Reference
     * @param string $version
     */
    public function __construct(\StructType\Business_AssetObjectType $business_Asset_Issue_Reference = null, $version = null)
    {
        $this
            ->setBusiness_Asset_Issue_Reference($business_Asset_Issue_Reference)
            ->setVersion($version);
    }
    /**
     * Get Business_Asset_Issue_Reference value
     * @return \StructType\Business_AssetObjectType|null
     */
    public function getBusiness_Asset_Issue_Reference()
    {
        return $this->Business_Asset_Issue_Reference;
    }
    /**
     * Set Business_Asset_Issue_Reference value
     * @param \StructType\Business_AssetObjectType $business_Asset_Issue_Reference
     * @return \StructType\Issue_Asset_ResponseType
     */
    public function setBusiness_Asset_Issue_Reference(\StructType\Business_AssetObjectType $business_Asset_Issue_Reference = null)
    {
        $this->Business_Asset_Issue_Reference = $business_Asset_Issue_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Issue_Asset_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
