<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_AssetType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper Element that includes Project Risk Instance and Data
 * @subpackage Structs
 */
class Project_AssetType extends AbstractStructBase
{
    /**
     * The Project_Asset_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Project Asset
     * - minOccurs: 0
     * @var \StructType\Project_AssetObjectType
     */
    public $Project_Asset_Reference;
    /**
     * The Project_Asset_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Project_Asset_DataType
     */
    public $Project_Asset_Data;
    /**
     * Constructor method for Project_AssetType
     * @uses Project_AssetType::setProject_Asset_Reference()
     * @uses Project_AssetType::setProject_Asset_Data()
     * @param \StructType\Project_AssetObjectType $project_Asset_Reference
     * @param \StructType\Project_Asset_DataType $project_Asset_Data
     */
    public function __construct(\StructType\Project_AssetObjectType $project_Asset_Reference = null, \StructType\Project_Asset_DataType $project_Asset_Data = null)
    {
        $this
            ->setProject_Asset_Reference($project_Asset_Reference)
            ->setProject_Asset_Data($project_Asset_Data);
    }
    /**
     * Get Project_Asset_Reference value
     * @return \StructType\Project_AssetObjectType|null
     */
    public function getProject_Asset_Reference()
    {
        return $this->Project_Asset_Reference;
    }
    /**
     * Set Project_Asset_Reference value
     * @param \StructType\Project_AssetObjectType $project_Asset_Reference
     * @return \StructType\Project_AssetType
     */
    public function setProject_Asset_Reference(\StructType\Project_AssetObjectType $project_Asset_Reference = null)
    {
        $this->Project_Asset_Reference = $project_Asset_Reference;
        return $this;
    }
    /**
     * Get Project_Asset_Data value
     * @return \StructType\Project_Asset_DataType|null
     */
    public function getProject_Asset_Data()
    {
        return $this->Project_Asset_Data;
    }
    /**
     * Set Project_Asset_Data value
     * @param \StructType\Project_Asset_DataType $project_Asset_Data
     * @return \StructType\Project_AssetType
     */
    public function setProject_Asset_Data(\StructType\Project_Asset_DataType $project_Asset_Data = null)
    {
        $this->Project_Asset_Data = $project_Asset_Data;
        return $this;
    }
}
