<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Asset_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Project Asset Reference
 * @subpackage Structs
 */
class Project_Asset_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Project_Asset_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Asset Reference
     * - maxOccurs: unbounded
     * @var \StructType\Project_AssetObjectType[]
     */
    public $Project_Asset_Reference;
    /**
     * Constructor method for Project_Asset_Request_ReferencesType
     * @uses Project_Asset_Request_ReferencesType::setProject_Asset_Reference()
     * @param \StructType\Project_AssetObjectType[] $project_Asset_Reference
     */
    public function __construct(array $project_Asset_Reference = array())
    {
        $this
            ->setProject_Asset_Reference($project_Asset_Reference);
    }
    /**
     * Get Project_Asset_Reference value
     * @return \StructType\Project_AssetObjectType[]|null
     */
    public function getProject_Asset_Reference()
    {
        return $this->Project_Asset_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Asset_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Asset_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_Asset_ReferenceForArrayConstraintsFromSetProject_Asset_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Asset_Request_ReferencesTypeProject_Asset_ReferenceItem) {
            // validation for constraint: itemType
            if (!$project_Asset_Request_ReferencesTypeProject_Asset_ReferenceItem instanceof \StructType\Project_AssetObjectType) {
                $invalidValues[] = is_object($project_Asset_Request_ReferencesTypeProject_Asset_ReferenceItem) ? get_class($project_Asset_Request_ReferencesTypeProject_Asset_ReferenceItem) : sprintf('%s(%s)', gettype($project_Asset_Request_ReferencesTypeProject_Asset_ReferenceItem), var_export($project_Asset_Request_ReferencesTypeProject_Asset_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Asset_Reference property can only contain items of type \StructType\Project_AssetObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Asset_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_AssetObjectType[] $project_Asset_Reference
     * @return \StructType\Project_Asset_Request_ReferencesType
     */
    public function setProject_Asset_Reference(array $project_Asset_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($project_Asset_ReferenceArrayErrorMessage = self::validateProject_Asset_ReferenceForArrayConstraintsFromSetProject_Asset_Reference($project_Asset_Reference))) {
            throw new \InvalidArgumentException($project_Asset_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Project_Asset_Reference = $project_Asset_Reference;
        return $this;
    }
    /**
     * Add item to Project_Asset_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_AssetObjectType $item
     * @return \StructType\Project_Asset_Request_ReferencesType
     */
    public function addToProject_Asset_Reference(\StructType\Project_AssetObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_AssetObjectType) {
            throw new \InvalidArgumentException(sprintf('The Project_Asset_Reference property can only contain items of type \StructType\Project_AssetObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Asset_Reference[] = $item;
        return $this;
    }
}
