<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Timesheet_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Encapsulates references to Project Timesheet
 * @subpackage Structs
 */
class Project_Timesheet_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Project_Timesheet_Reference
     * Meta information extracted from the WSDL
     * - documentation: References specified to instances of Project Timesheet
     * - maxOccurs: unbounded
     * @var \StructType\Project_TimesheetObjectType[]
     */
    public $Project_Timesheet_Reference;
    /**
     * Constructor method for Project_Timesheet_Request_ReferencesType
     * @uses Project_Timesheet_Request_ReferencesType::setProject_Timesheet_Reference()
     * @param \StructType\Project_TimesheetObjectType[] $project_Timesheet_Reference
     */
    public function __construct(array $project_Timesheet_Reference = array())
    {
        $this
            ->setProject_Timesheet_Reference($project_Timesheet_Reference);
    }
    /**
     * Get Project_Timesheet_Reference value
     * @return \StructType\Project_TimesheetObjectType[]|null
     */
    public function getProject_Timesheet_Reference()
    {
        return $this->Project_Timesheet_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Timesheet_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Timesheet_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_Timesheet_ReferenceForArrayConstraintsFromSetProject_Timesheet_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Timesheet_Request_ReferencesTypeProject_Timesheet_ReferenceItem) {
            // validation for constraint: itemType
            if (!$project_Timesheet_Request_ReferencesTypeProject_Timesheet_ReferenceItem instanceof \StructType\Project_TimesheetObjectType) {
                $invalidValues[] = is_object($project_Timesheet_Request_ReferencesTypeProject_Timesheet_ReferenceItem) ? get_class($project_Timesheet_Request_ReferencesTypeProject_Timesheet_ReferenceItem) : sprintf('%s(%s)', gettype($project_Timesheet_Request_ReferencesTypeProject_Timesheet_ReferenceItem), var_export($project_Timesheet_Request_ReferencesTypeProject_Timesheet_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Timesheet_Reference property can only contain items of type \StructType\Project_TimesheetObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Timesheet_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_TimesheetObjectType[] $project_Timesheet_Reference
     * @return \StructType\Project_Timesheet_Request_ReferencesType
     */
    public function setProject_Timesheet_Reference(array $project_Timesheet_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($project_Timesheet_ReferenceArrayErrorMessage = self::validateProject_Timesheet_ReferenceForArrayConstraintsFromSetProject_Timesheet_Reference($project_Timesheet_Reference))) {
            throw new \InvalidArgumentException($project_Timesheet_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Project_Timesheet_Reference = $project_Timesheet_Reference;
        return $this;
    }
    /**
     * Add item to Project_Timesheet_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_TimesheetObjectType $item
     * @return \StructType\Project_Timesheet_Request_ReferencesType
     */
    public function addToProject_Timesheet_Reference(\StructType\Project_TimesheetObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_TimesheetObjectType) {
            throw new \InvalidArgumentException(sprintf('The Project_Timesheet_Reference property can only contain items of type \StructType\Project_TimesheetObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Timesheet_Reference[] = $item;
        return $this;
    }
}
