<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Requisition_Additional_Data_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains the Requisition additional data.
 * @subpackage Structs
 */
class Put_Requisition_Additional_Data_ResponseType extends AbstractStructBase
{
    /**
     * The Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Requisition reference
     * - minOccurs: 0
     * @var \StructType\RequisitionObjectType
     */
    public $Requisition_Reference;
    /**
     * The Business_Object_Additional_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Non_Effective_Dated_Web_Service_Additional_DataType
     */
    public $Business_Object_Additional_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Requisition_Additional_Data_ResponseType
     * @uses Put_Requisition_Additional_Data_ResponseType::setRequisition_Reference()
     * @uses Put_Requisition_Additional_Data_ResponseType::setBusiness_Object_Additional_Data()
     * @uses Put_Requisition_Additional_Data_ResponseType::setVersion()
     * @param \StructType\RequisitionObjectType $requisition_Reference
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     * @param string $version
     */
    public function __construct(\StructType\RequisitionObjectType $requisition_Reference = null, \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null, $version = null)
    {
        $this
            ->setRequisition_Reference($requisition_Reference)
            ->setBusiness_Object_Additional_Data($business_Object_Additional_Data)
            ->setVersion($version);
    }
    /**
     * Get Requisition_Reference value
     * @return \StructType\RequisitionObjectType|null
     */
    public function getRequisition_Reference()
    {
        return $this->Requisition_Reference;
    }
    /**
     * Set Requisition_Reference value
     * @param \StructType\RequisitionObjectType $requisition_Reference
     * @return \StructType\Put_Requisition_Additional_Data_ResponseType
     */
    public function setRequisition_Reference(\StructType\RequisitionObjectType $requisition_Reference = null)
    {
        $this->Requisition_Reference = $requisition_Reference;
        return $this;
    }
    /**
     * Get Business_Object_Additional_Data value
     * @return \StructType\Non_Effective_Dated_Web_Service_Additional_DataType|null
     */
    public function getBusiness_Object_Additional_Data()
    {
        return $this->Business_Object_Additional_Data;
    }
    /**
     * Set Business_Object_Additional_Data value
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     * @return \StructType\Put_Requisition_Additional_Data_ResponseType
     */
    public function setBusiness_Object_Additional_Data(\StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this->Business_Object_Additional_Data = $business_Object_Additional_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Requisition_Additional_Data_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
