<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Resource_Pool_Hierarchy_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Resource Pool Hierarchy Response Element.
 * @subpackage Structs
 */
class Put_Resource_Pool_Hierarchy_ResponseType extends AbstractStructBase
{
    /**
     * The Resource_Pool_Hierarchy_Reference
     * Meta information extracted from the WSDL
     * - documentation: Resource Pool Hierarchy Instance in Response.
     * - minOccurs: 0
     * @var \StructType\Resource_Pool_HierarchyObjectType
     */
    public $Resource_Pool_Hierarchy_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Resource_Pool_Hierarchy_ResponseType
     * @uses Put_Resource_Pool_Hierarchy_ResponseType::setResource_Pool_Hierarchy_Reference()
     * @uses Put_Resource_Pool_Hierarchy_ResponseType::setVersion()
     * @param \StructType\Resource_Pool_HierarchyObjectType $resource_Pool_Hierarchy_Reference
     * @param string $version
     */
    public function __construct(\StructType\Resource_Pool_HierarchyObjectType $resource_Pool_Hierarchy_Reference = null, $version = null)
    {
        $this
            ->setResource_Pool_Hierarchy_Reference($resource_Pool_Hierarchy_Reference)
            ->setVersion($version);
    }
    /**
     * Get Resource_Pool_Hierarchy_Reference value
     * @return \StructType\Resource_Pool_HierarchyObjectType|null
     */
    public function getResource_Pool_Hierarchy_Reference()
    {
        return $this->Resource_Pool_Hierarchy_Reference;
    }
    /**
     * Set Resource_Pool_Hierarchy_Reference value
     * @param \StructType\Resource_Pool_HierarchyObjectType $resource_Pool_Hierarchy_Reference
     * @return \StructType\Put_Resource_Pool_Hierarchy_ResponseType
     */
    public function setResource_Pool_Hierarchy_Reference(\StructType\Resource_Pool_HierarchyObjectType $resource_Pool_Hierarchy_Reference = null)
    {
        $this->Resource_Pool_Hierarchy_Reference = $resource_Pool_Hierarchy_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Resource_Pool_Hierarchy_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
