<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Supplier_Group_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Put Supplier Group Response Data
 * @subpackage Structs
 */
class Put_Supplier_Group_ResponseType extends AbstractStructBase
{
    /**
     * The Supplier_Group_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Supplier Group
     * - minOccurs: 0
     * @var \StructType\Supplier_GroupObjectType
     */
    public $Supplier_Group_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Supplier_Group_ResponseType
     * @uses Put_Supplier_Group_ResponseType::setSupplier_Group_Reference()
     * @uses Put_Supplier_Group_ResponseType::setVersion()
     * @param \StructType\Supplier_GroupObjectType $supplier_Group_Reference
     * @param string $version
     */
    public function __construct(\StructType\Supplier_GroupObjectType $supplier_Group_Reference = null, $version = null)
    {
        $this
            ->setSupplier_Group_Reference($supplier_Group_Reference)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Group_Reference value
     * @return \StructType\Supplier_GroupObjectType|null
     */
    public function getSupplier_Group_Reference()
    {
        return $this->Supplier_Group_Reference;
    }
    /**
     * Set Supplier_Group_Reference value
     * @param \StructType\Supplier_GroupObjectType $supplier_Group_Reference
     * @return \StructType\Put_Supplier_Group_ResponseType
     */
    public function setSupplier_Group_Reference(\StructType\Supplier_GroupObjectType $supplier_Group_Reference = null)
    {
        $this->Supplier_Group_Reference = $supplier_Group_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Group_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
