<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Supplier_Payment_Memo_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Supplier Payment Memo Request
 * @subpackage Structs
 */
class Put_Supplier_Payment_Memo_RequestType extends AbstractStructBase
{
    /**
     * The Supplier_Payment_Reference
     * Meta information extracted from the WSDL
     * - documentation: Payment Reference
     * @var \StructType\Supplier_Payment_for_InvoicesObjectType
     */
    public $Supplier_Payment_Reference;
    /**
     * The Supplier_Payment_Memo_Data
     * Meta information extracted from the WSDL
     * - documentation: Supplier Payment Memo Data
     * - minOccurs: 0
     * @var \StructType\Supplier_Payment_Memo_DataType
     */
    public $Supplier_Payment_Memo_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Supplier_Payment_Memo_RequestType
     * @uses Put_Supplier_Payment_Memo_RequestType::setSupplier_Payment_Reference()
     * @uses Put_Supplier_Payment_Memo_RequestType::setSupplier_Payment_Memo_Data()
     * @uses Put_Supplier_Payment_Memo_RequestType::setVersion()
     * @param \StructType\Supplier_Payment_for_InvoicesObjectType $supplier_Payment_Reference
     * @param \StructType\Supplier_Payment_Memo_DataType $supplier_Payment_Memo_Data
     * @param string $version
     */
    public function __construct(\StructType\Supplier_Payment_for_InvoicesObjectType $supplier_Payment_Reference = null, \StructType\Supplier_Payment_Memo_DataType $supplier_Payment_Memo_Data = null, $version = null)
    {
        $this
            ->setSupplier_Payment_Reference($supplier_Payment_Reference)
            ->setSupplier_Payment_Memo_Data($supplier_Payment_Memo_Data)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Payment_Reference value
     * @return \StructType\Supplier_Payment_for_InvoicesObjectType|null
     */
    public function getSupplier_Payment_Reference()
    {
        return $this->Supplier_Payment_Reference;
    }
    /**
     * Set Supplier_Payment_Reference value
     * @param \StructType\Supplier_Payment_for_InvoicesObjectType $supplier_Payment_Reference
     * @return \StructType\Put_Supplier_Payment_Memo_RequestType
     */
    public function setSupplier_Payment_Reference(\StructType\Supplier_Payment_for_InvoicesObjectType $supplier_Payment_Reference = null)
    {
        $this->Supplier_Payment_Reference = $supplier_Payment_Reference;
        return $this;
    }
    /**
     * Get Supplier_Payment_Memo_Data value
     * @return \StructType\Supplier_Payment_Memo_DataType|null
     */
    public function getSupplier_Payment_Memo_Data()
    {
        return $this->Supplier_Payment_Memo_Data;
    }
    /**
     * Set Supplier_Payment_Memo_Data value
     * @param \StructType\Supplier_Payment_Memo_DataType $supplier_Payment_Memo_Data
     * @return \StructType\Put_Supplier_Payment_Memo_RequestType
     */
    public function setSupplier_Payment_Memo_Data(\StructType\Supplier_Payment_Memo_DataType $supplier_Payment_Memo_Data = null)
    {
        $this->Supplier_Payment_Memo_Data = $supplier_Payment_Memo_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Payment_Memo_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
