<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Transfer_Pricing_Rate_Sheet_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Put operation.
 * @subpackage Structs
 */
class Put_Transfer_Pricing_Rate_Sheet_ResponseType extends AbstractStructBase
{
    /**
     * The Transfer_Pricing_Rate_Sheet_Reference
     * Meta information extracted from the WSDL
     * - documentation: Contains transfer pricing rate sheet instances.
     * - minOccurs: 0
     * @var \StructType\Transfer_Pricing_Rate_SheetObjectType
     */
    public $Transfer_Pricing_Rate_Sheet_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Transfer_Pricing_Rate_Sheet_ResponseType
     * @uses Put_Transfer_Pricing_Rate_Sheet_ResponseType::setTransfer_Pricing_Rate_Sheet_Reference()
     * @uses Put_Transfer_Pricing_Rate_Sheet_ResponseType::setVersion()
     * @param \StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference
     * @param string $version
     */
    public function __construct(\StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference = null, $version = null)
    {
        $this
            ->setTransfer_Pricing_Rate_Sheet_Reference($transfer_Pricing_Rate_Sheet_Reference)
            ->setVersion($version);
    }
    /**
     * Get Transfer_Pricing_Rate_Sheet_Reference value
     * @return \StructType\Transfer_Pricing_Rate_SheetObjectType|null
     */
    public function getTransfer_Pricing_Rate_Sheet_Reference()
    {
        return $this->Transfer_Pricing_Rate_Sheet_Reference;
    }
    /**
     * Set Transfer_Pricing_Rate_Sheet_Reference value
     * @param \StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference
     * @return \StructType\Put_Transfer_Pricing_Rate_Sheet_ResponseType
     */
    public function setTransfer_Pricing_Rate_Sheet_Reference(\StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference = null)
    {
        $this->Transfer_Pricing_Rate_Sheet_Reference = $transfer_Pricing_Rate_Sheet_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Transfer_Pricing_Rate_Sheet_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
