<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Reassign_Expense_Credit_Card_Transaction_RequestType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: This web service only supports the reassignment of Worker Credit Card Transactions. | The selected transaction is currently on an expense report. To reassign this transaction, remove it from the current expense report. | The selected
 * transaction doesn't have an assigned worker credit card and is unavailable for reassignment. | Enable reassignment on the associated worker credit card to reassign transaction. | Request Element containing Expense Credit Card Transaction reference
 * and New Expense Payee Reference for updating transaction with new expense payee
 * @subpackage Structs
 */
class Reassign_Expense_Credit_Card_Transaction_RequestType extends AbstractStructBase
{
    /**
     * The Expense_Credit_Card_Transaction_Reference
     * Meta information extracted from the WSDL
     * - documentation: This is the reference to credit card transaction.
     * @var \StructType\Credit_Card_TransactionObjectType
     */
    public $Expense_Credit_Card_Transaction_Reference;
    /**
     * The Expense_Credit_Card_Transaction_Data
     * @var \StructType\Expense_Credit_Card_Transaction_Assignee_DataType
     */
    public $Expense_Credit_Card_Transaction_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Reassign_Expense_Credit_Card_Transaction_RequestType
     * @uses Reassign_Expense_Credit_Card_Transaction_RequestType::setExpense_Credit_Card_Transaction_Reference()
     * @uses Reassign_Expense_Credit_Card_Transaction_RequestType::setExpense_Credit_Card_Transaction_Data()
     * @uses Reassign_Expense_Credit_Card_Transaction_RequestType::setVersion()
     * @param \StructType\Credit_Card_TransactionObjectType $expense_Credit_Card_Transaction_Reference
     * @param \StructType\Expense_Credit_Card_Transaction_Assignee_DataType $expense_Credit_Card_Transaction_Data
     * @param string $version
     */
    public function __construct(\StructType\Credit_Card_TransactionObjectType $expense_Credit_Card_Transaction_Reference = null, \StructType\Expense_Credit_Card_Transaction_Assignee_DataType $expense_Credit_Card_Transaction_Data = null, $version = null)
    {
        $this
            ->setExpense_Credit_Card_Transaction_Reference($expense_Credit_Card_Transaction_Reference)
            ->setExpense_Credit_Card_Transaction_Data($expense_Credit_Card_Transaction_Data)
            ->setVersion($version);
    }
    /**
     * Get Expense_Credit_Card_Transaction_Reference value
     * @return \StructType\Credit_Card_TransactionObjectType|null
     */
    public function getExpense_Credit_Card_Transaction_Reference()
    {
        return $this->Expense_Credit_Card_Transaction_Reference;
    }
    /**
     * Set Expense_Credit_Card_Transaction_Reference value
     * @param \StructType\Credit_Card_TransactionObjectType $expense_Credit_Card_Transaction_Reference
     * @return \StructType\Reassign_Expense_Credit_Card_Transaction_RequestType
     */
    public function setExpense_Credit_Card_Transaction_Reference(\StructType\Credit_Card_TransactionObjectType $expense_Credit_Card_Transaction_Reference = null)
    {
        $this->Expense_Credit_Card_Transaction_Reference = $expense_Credit_Card_Transaction_Reference;
        return $this;
    }
    /**
     * Get Expense_Credit_Card_Transaction_Data value
     * @return \StructType\Expense_Credit_Card_Transaction_Assignee_DataType|null
     */
    public function getExpense_Credit_Card_Transaction_Data()
    {
        return $this->Expense_Credit_Card_Transaction_Data;
    }
    /**
     * Set Expense_Credit_Card_Transaction_Data value
     * @param \StructType\Expense_Credit_Card_Transaction_Assignee_DataType $expense_Credit_Card_Transaction_Data
     * @return \StructType\Reassign_Expense_Credit_Card_Transaction_RequestType
     */
    public function setExpense_Credit_Card_Transaction_Data(\StructType\Expense_Credit_Card_Transaction_Assignee_DataType $expense_Credit_Card_Transaction_Data = null)
    {
        $this->Expense_Credit_Card_Transaction_Data = $expense_Credit_Card_Transaction_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Reassign_Expense_Credit_Card_Transaction_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
