<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Revenue_CenterType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Revenue Center reference for GET Revenue Center data.
 * @subpackage Structs
 */
class Revenue_CenterType extends AbstractStructBase
{
    /**
     * The Revenue_Center_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Revenue Center
     * - minOccurs: 0
     * @var \StructType\Revenue_CenterObjectType
     */
    public $Revenue_Center_Reference;
    /**
     * The Revenue_Center_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Revenue_Center_DataType
     */
    public $Revenue_Center_Data;
    /**
     * Constructor method for Revenue_CenterType
     * @uses Revenue_CenterType::setRevenue_Center_Reference()
     * @uses Revenue_CenterType::setRevenue_Center_Data()
     * @param \StructType\Revenue_CenterObjectType $revenue_Center_Reference
     * @param \StructType\Revenue_Center_DataType $revenue_Center_Data
     */
    public function __construct(\StructType\Revenue_CenterObjectType $revenue_Center_Reference = null, \StructType\Revenue_Center_DataType $revenue_Center_Data = null)
    {
        $this
            ->setRevenue_Center_Reference($revenue_Center_Reference)
            ->setRevenue_Center_Data($revenue_Center_Data);
    }
    /**
     * Get Revenue_Center_Reference value
     * @return \StructType\Revenue_CenterObjectType|null
     */
    public function getRevenue_Center_Reference()
    {
        return $this->Revenue_Center_Reference;
    }
    /**
     * Set Revenue_Center_Reference value
     * @param \StructType\Revenue_CenterObjectType $revenue_Center_Reference
     * @return \StructType\Revenue_CenterType
     */
    public function setRevenue_Center_Reference(\StructType\Revenue_CenterObjectType $revenue_Center_Reference = null)
    {
        $this->Revenue_Center_Reference = $revenue_Center_Reference;
        return $this;
    }
    /**
     * Get Revenue_Center_Data value
     * @return \StructType\Revenue_Center_DataType|null
     */
    public function getRevenue_Center_Data()
    {
        return $this->Revenue_Center_Data;
    }
    /**
     * Set Revenue_Center_Data value
     * @param \StructType\Revenue_Center_DataType $revenue_Center_Data
     * @return \StructType\Revenue_CenterType
     */
    public function setRevenue_Center_Data(\StructType\Revenue_Center_DataType $revenue_Center_Data = null)
    {
        $this->Revenue_Center_Data = $revenue_Center_Data;
        return $this;
    }
}
