<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_Contact_InformationType StructType
 * Meta information extracted from the WSDL
 * - documentation: Response to Get Supplier Contact Information
 * @subpackage Structs
 */
class Supplier_Contact_InformationType extends AbstractStructBase
{
    /**
     * The Supplier_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier containing Contact Information
     * @var \StructType\SupplierObjectType
     */
    public $Supplier_Reference;
    /**
     * The Supplier_Contact_Information_Data
     * Meta information extracted from the WSDL
     * - documentation: Contact Information for the Supplier
     * - minOccurs: 0
     * @var \StructType\Contact_Information_Wrapper_DataType
     */
    public $Supplier_Contact_Information_Data;
    /**
     * Constructor method for Supplier_Contact_InformationType
     * @uses Supplier_Contact_InformationType::setSupplier_Reference()
     * @uses Supplier_Contact_InformationType::setSupplier_Contact_Information_Data()
     * @param \StructType\SupplierObjectType $supplier_Reference
     * @param \StructType\Contact_Information_Wrapper_DataType $supplier_Contact_Information_Data
     */
    public function __construct(\StructType\SupplierObjectType $supplier_Reference = null, \StructType\Contact_Information_Wrapper_DataType $supplier_Contact_Information_Data = null)
    {
        $this
            ->setSupplier_Reference($supplier_Reference)
            ->setSupplier_Contact_Information_Data($supplier_Contact_Information_Data);
    }
    /**
     * Get Supplier_Reference value
     * @return \StructType\SupplierObjectType|null
     */
    public function getSupplier_Reference()
    {
        return $this->Supplier_Reference;
    }
    /**
     * Set Supplier_Reference value
     * @param \StructType\SupplierObjectType $supplier_Reference
     * @return \StructType\Supplier_Contact_InformationType
     */
    public function setSupplier_Reference(\StructType\SupplierObjectType $supplier_Reference = null)
    {
        $this->Supplier_Reference = $supplier_Reference;
        return $this;
    }
    /**
     * Get Supplier_Contact_Information_Data value
     * @return \StructType\Contact_Information_Wrapper_DataType|null
     */
    public function getSupplier_Contact_Information_Data()
    {
        return $this->Supplier_Contact_Information_Data;
    }
    /**
     * Set Supplier_Contact_Information_Data value
     * @param \StructType\Contact_Information_Wrapper_DataType $supplier_Contact_Information_Data
     * @return \StructType\Supplier_Contact_InformationType
     */
    public function setSupplier_Contact_Information_Data(\StructType\Contact_Information_Wrapper_DataType $supplier_Contact_Information_Data = null)
    {
        $this->Supplier_Contact_Information_Data = $supplier_Contact_Information_Data;
        return $this;
    }
}
