<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_Invoice_HistoryType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper for a single Supplier Invoice History object and its data being returned by the "Get" operation.
 * @subpackage Structs
 */
class Supplier_Invoice_HistoryType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_History_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to a Supplier Invoice History object being returned by the "Get" operation.
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_HistoryObjectType
     */
    public $Supplier_Invoice_History_Reference;
    /**
     * The Supplier_Invoice_History_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_History_DataType
     */
    public $Supplier_Invoice_History_Data;
    /**
     * Constructor method for Supplier_Invoice_HistoryType
     * @uses Supplier_Invoice_HistoryType::setSupplier_Invoice_History_Reference()
     * @uses Supplier_Invoice_HistoryType::setSupplier_Invoice_History_Data()
     * @param \StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference
     * @param \StructType\Supplier_Invoice_History_DataType $supplier_Invoice_History_Data
     */
    public function __construct(\StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference = null, \StructType\Supplier_Invoice_History_DataType $supplier_Invoice_History_Data = null)
    {
        $this
            ->setSupplier_Invoice_History_Reference($supplier_Invoice_History_Reference)
            ->setSupplier_Invoice_History_Data($supplier_Invoice_History_Data);
    }
    /**
     * Get Supplier_Invoice_History_Reference value
     * @return \StructType\Supplier_Invoice_HistoryObjectType|null
     */
    public function getSupplier_Invoice_History_Reference()
    {
        return $this->Supplier_Invoice_History_Reference;
    }
    /**
     * Set Supplier_Invoice_History_Reference value
     * @param \StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference
     * @return \StructType\Supplier_Invoice_HistoryType
     */
    public function setSupplier_Invoice_History_Reference(\StructType\Supplier_Invoice_HistoryObjectType $supplier_Invoice_History_Reference = null)
    {
        $this->Supplier_Invoice_History_Reference = $supplier_Invoice_History_Reference;
        return $this;
    }
    /**
     * Get Supplier_Invoice_History_Data value
     * @return \StructType\Supplier_Invoice_History_DataType|null
     */
    public function getSupplier_Invoice_History_Data()
    {
        return $this->Supplier_Invoice_History_Data;
    }
    /**
     * Set Supplier_Invoice_History_Data value
     * @param \StructType\Supplier_Invoice_History_DataType $supplier_Invoice_History_Data
     * @return \StructType\Supplier_Invoice_HistoryType
     */
    public function setSupplier_Invoice_History_Data(\StructType\Supplier_Invoice_History_DataType $supplier_Invoice_History_Data = null)
    {
        $this->Supplier_Invoice_History_Data = $supplier_Invoice_History_Data;
        return $this;
    }
}
