<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * Supplier_Invoice_System_Validation_Configuration_Response_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper Element that includes Supplier Invoice System Validation Configuration Data
 * @subpackage Structs
 */
class Supplier_Invoice_System_Validation_Configuration_Response_DataType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_System_Validation_Configuration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_System_Validation_ConfigurationType[]
     */
    public $Supplier_Invoice_System_Validation_Configuration;
    /**
     * Constructor method for
     * Supplier_Invoice_System_Validation_Configuration_Response_DataType
     * @uses Supplier_Invoice_System_Validation_Configuration_Response_DataType::setSupplier_Invoice_System_Validation_Configuration()
     * @param \StructType\Supplier_Invoice_System_Validation_ConfigurationType[] $supplier_Invoice_System_Validation_Configuration
     */
    public function __construct(array $supplier_Invoice_System_Validation_Configuration = array())
    {
        $this
            ->setSupplier_Invoice_System_Validation_Configuration($supplier_Invoice_System_Validation_Configuration);
    }
    /**
     * Get Supplier_Invoice_System_Validation_Configuration value
     * @return \StructType\Supplier_Invoice_System_Validation_ConfigurationType[]|null
     */
    public function getSupplier_Invoice_System_Validation_Configuration()
    {
        return $this->Supplier_Invoice_System_Validation_Configuration;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplier_Invoice_System_Validation_Configuration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplier_Invoice_System_Validation_Configuration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplier_Invoice_System_Validation_ConfigurationForArrayConstraintsFromSetSupplier_Invoice_System_Validation_Configuration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $supplier_Invoice_System_Validation_Configuration_Response_DataTypeSupplier_Invoice_System_Validation_ConfigurationItem) {
            // validation for constraint: itemType
            if (!$supplier_Invoice_System_Validation_Configuration_Response_DataTypeSupplier_Invoice_System_Validation_ConfigurationItem instanceof \StructType\Supplier_Invoice_System_Validation_ConfigurationType) {
                $invalidValues[] = is_object($supplier_Invoice_System_Validation_Configuration_Response_DataTypeSupplier_Invoice_System_Validation_ConfigurationItem) ? get_class($supplier_Invoice_System_Validation_Configuration_Response_DataTypeSupplier_Invoice_System_Validation_ConfigurationItem) : sprintf('%s(%s)', gettype($supplier_Invoice_System_Validation_Configuration_Response_DataTypeSupplier_Invoice_System_Validation_ConfigurationItem), var_export($supplier_Invoice_System_Validation_Configuration_Response_DataTypeSupplier_Invoice_System_Validation_ConfigurationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Supplier_Invoice_System_Validation_Configuration property can only contain items of type \StructType\Supplier_Invoice_System_Validation_ConfigurationType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Supplier_Invoice_System_Validation_Configuration value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_System_Validation_ConfigurationType[] $supplier_Invoice_System_Validation_Configuration
     * @return \StructType\Supplier_Invoice_System_Validation_Configuration_Response_DataType
     */
    public function setSupplier_Invoice_System_Validation_Configuration(array $supplier_Invoice_System_Validation_Configuration = array())
    {
        // validation for constraint: array
        if ('' !== ($supplier_Invoice_System_Validation_ConfigurationArrayErrorMessage = self::validateSupplier_Invoice_System_Validation_ConfigurationForArrayConstraintsFromSetSupplier_Invoice_System_Validation_Configuration($supplier_Invoice_System_Validation_Configuration))) {
            throw new \InvalidArgumentException($supplier_Invoice_System_Validation_ConfigurationArrayErrorMessage, __LINE__);
        }
        $this->Supplier_Invoice_System_Validation_Configuration = $supplier_Invoice_System_Validation_Configuration;
        return $this;
    }
    /**
     * Add item to Supplier_Invoice_System_Validation_Configuration value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_System_Validation_ConfigurationType $item
     * @return \StructType\Supplier_Invoice_System_Validation_Configuration_Response_DataType
     */
    public function addToSupplier_Invoice_System_Validation_Configuration(\StructType\Supplier_Invoice_System_Validation_ConfigurationType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Supplier_Invoice_System_Validation_ConfigurationType) {
            throw new \InvalidArgumentException(sprintf('The Supplier_Invoice_System_Validation_Configuration property can only contain items of type \StructType\Supplier_Invoice_System_Validation_ConfigurationType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Supplier_Invoice_System_Validation_Configuration[] = $item;
        return $this;
    }
}
